diff --git a/scripts/install_whonix_qubes/INSTALL.md b/scripts/install_whonix_qubes/INSTALL.md
new file mode 100644
index 0000000000..c56b35cacd
--- /dev/null
+++ b/scripts/install_whonix_qubes/INSTALL.md
@@ -0,0 +1,401 @@
+# Haveno on Qubes/Whonix
+
+## **Conventions:**
+
++ \# – Requires given linux commands to be executed with root privileges either directly as a root user or by use of sudo command
+
++ $ or % – Requires given linux commands to be executed as a regular non-privileged user
+
++ \<VAR> – Used to indicate user supplied variable
+
+---
+
+## **Installation - Scripted & Manual (GUI + CLI):**
+### *Acquire release files:*
+#### In `dispXXXX` AppVM:
+##### Clone repository
+```shell
+% git clone --depth=1 https://github.com/haveno-dex/haveno
+```
+
+---
+
+### **Create TemplateVM, NetVM & AppVM:**
+#### Scripted
+##### In `dispXXXX` AppVM:
+###### Prepare files for transfer to `dom0`
+```shell
+% tar -C haveno/scripts/install_qubes/scripts/0-dom0 -zcvf /tmp/haveno.tgz .
+```
+
+##### In `dom0`:
+###### Copy files to `dom0`
+```shell
+$ mkdir -p /tmp/haveno && qvm-run -p dispXXXX 'cat /tmp/haveno.tgz' > /tmp/haveno.tgz && tar -C /tmp/haveno -zxfv /tmp/haveno.tgz
+$ bash /tmp/haveno/0.0-dom0.sh && bash /tmp/haveno/0.1-dom0.sh && bash /tmp/haveno/0.2-dom0.sh
+```
+
+#### GUI
+##### TemplateVM
+###### Via `Qubes Manager`:
+
++ Locate & highlight whonix-workstation-17 (TemplateVM)
+
++ Right-Click "whonix-workstation-17" and select "Clone qube" from Drop-Down
+
++ Enter "haveno-template" in "Name"
+
++ Click OK Button
+
+##### NetVM
+###### Via `Qubes Manager`:
+
++ Click "New qube" Button
+
++ Enter "sys-haveno" for "Name and label"
+
++ Click the Button Beside "Name and label" and Select "orange"
+
++ Select "whonix-gateway-17" from "Template" Drop-Down
+
++ Select "sys-firewall" from "Networking" Drop-Down
+
++ Tick "Launch settings after creation" Radio-Box
+
++ Click OK
+
++ Click "Advanced" Tab
+
++ Enter "512" for "Initial memory"
+
+<p style="text-align: center;"><em>(Within reason, can adjust to personal preference)</em></p>
+
++ Enter "512" for "Max memory"
+
+<p style="text-align: center;"><em>(Within reason, can adjust to personal preference)</em></p>
+
++ Tick "Provides network" Radio-Box
+
++ Click "Apply" Button
+
++ Click "OK" Button
+
+##### AppVM
+###### Via `Qubes Manager`:
+
++ Click "New qube" Button
+
++ Enter "haveno" for "Name and label"
+
++ Click the Button Beside "Name and label" and Select "orange"
+
++ Select "haveno-template" from "Template" Drop-Down
+
++ Select "sys-haveno" from "Networking" Drop-Down
+
++ Tick "Launch settings after creation" Radio-Box
+
++ Click OK
+
++ Click "Advanced" Tab
+
++ Enter "2048" for "Initial memory"
+
+<p style="text-align: center;"><em>(Within reason, can adjust to personal preference)</em></p>
+
++ Enter "4096" for "Max memory"
+
+<p style="text-align: center;"><em>(Within reason, can adjust to personal preference)</em></p>
+
++ Click "Apply" Button
+
++ Click "OK" Button
+
+
+#### CLI
+##### TemplateVM
+###### In `dom0`:
+```shell
+$ qvm-clone whonix-workstation-17 haveno-template
+```
+
+##### NetVM
+##### In `dom0`:
+```shell
+$ qvm-create --template whonix-gateway-17 --class AppVM --label=orange --property memory=512 --property maxmem=512 --property netvm=sys-firewall sys-haveno && qvm-prefs --set sys-haveno provides_network True
+```
+
+#### AppVM
+##### In `dom0`:
+```shell
+$ qvm-create --template haveno-template --class AppVM --label=orange --property memory=2048 --property maxmem=4096 --property netvm=sys-haveno haveno
+$ printf 'haveno-Haveno.desktop' | qvm-appmenus --set-whitelist – haveno
+```
+
+---
+
+### **Build TemplateVM, NetVM & AppVM:**
+#### *TemplateVM Using Precompiled Package via `git` Repository (Scripted)*
+##### In `dispXXXX` AppVM:
+```shell
+% qvm-copy haveno/scripts/install_qubes/scripts/1-TemplateVM/1.0-haveno-templatevm.sh
+```
+
++ Select "haveno-template" for "Target" of Pop-Up
+
++ Click OK
+
+##### In `haveno-template` TemplateVM:
+```shell
+% sudo bash QubesIncoming/dispXXXX/1.0-haveno-templatevm.sh "<PACKAGE_ARCHIVE_URL>" "<PACKAGE_PGP_FINGERPRINT>"
+```
+
+<p style="text-align: center;">Example:</p>
+
+```shell
+% sudo bash QubesIncoming/dispXXXX/1.0-haveno-templatevm.sh "https://github.com/havenoexample/haveno-example/releases/download/v1.0.18/haveno-linux-deb.zip" "ABAF11C65A2970B130ABE3C479BE3E4300411886"
+```
+
+#### *TemplateVM Using Precompiled Package From `git` Repository (CLI)*
+##### In `haveno-template` TemplateVM:
+###### Download & Import Project PGP Key
+<p style="text-align: center;">For Whonix On Qubes OS:</p>
+
+```shell
+# export https_proxy=http://127.0.0.1:8082
+# export KEY_SEARCH="<PACKAGE_PGP_FINGERPRINT>"
+# curl -sL "https://keyserver.ubuntu.com/pks/lookup?op=get&search=0x$KEY_SEARCH" | gpg --import
+```
+
+<p style="text-align: center;">Example:</p>
+
+```shell
+# export https_proxy=http://127.0.0.1:8082
+# export KEY_SEARCH="ABAF11C65A2970B130ABE3C479BE3E4300411886"
+# curl -sL "https://keyserver.ubuntu.com/pks/lookup?op=get&search=0x$KEY_SEARCH" | gpg --import
+```
+
+<p style="text-align: center;">For Whonix On Anything Other Than Qubes OS:</p>
+
+```shell
+# export KEY_SEARCH="<PACKAGE_PGP_FINGERPRINT>"
+# curl -sL "https://keyserver.ubuntu.com/pks/lookup?op=get&search=0x$KEY_SEARCH" | gpg --import
+```
+
+<p style="text-align: center;">Example:</p>
+
+```shell
+# export KEY_SEARCH="ABAF11C65A2970B130ABE3C479BE3E4300411886"
+# curl -sL "https://keyserver.ubuntu.com/pks/lookup?op=get&search=0x$KEY_SEARCH" | gpg --import
+```
+
+
+###### Download Release Files
+<p style="text-align: center;">For Whonix On Qubes OS:</p>
+
+```shell
+# export https_proxy=http://127.0.0.1:8082
+# curl -sSLo /tmp/hashes.txt https://github.com/havenoexample/haveno-example/releases/download/v1.0.18/1.0.18-hashes.txt
+# curl -sSLo /tmp/hashes.txt.sig https://github.com/havenoexample/haveno-example/releases/download/v1.0.18/1.0.18-hashes.txt.sig
+# curl -sSLo /tmp/haveno.zip https://github.com/havenoexample/haveno-example/releases/download/v1.0.18/haveno_amd64_deb-latest.zip
+# curl -sSLo /tmp/haveno.zip.sig https://github.com/havenoexample/haveno-example/releases/download/v1.0.18/haveno_amd64_deb-latest.zip.sig
+```
+
+<p style="text-align: center;">Note:</p>
+<p style="text-align: center;"><em>Above are dummy URLS which MUST be replaced with actual working URLs</em></p>
+
+<p style="text-align: center;">For Whonix On Anything Other Than Qubes OS:</p>
+
+```shell
+# curl -sSLo /tmp/hashes.txt https://github.com/havenoexample/haveno-example/releases/download/v1.0.18/1.0.18-hashes.txt
+# curl -sSLo /tmp/hashes.txt.sig https://github.com/havenoexample/haveno-example/releases/download/v1.0.18/1.0.18-hashes.txt.sig
+# curl -sSLo /tmp/haveno.zip https://github.com/havenoexample/haveno-example/releases/download/v1.0.18/haveno_amd64_deb-latest.zip
+# curl -sSLo /tmp/haveno.zip.sig https://github.com/havenoexample/haveno-example/releases/download/v1.0.18/haveno_amd64_deb-latest.zip.sig
+```
+
+<p style="text-align: center;">Note:</p>
+<p style="text-align: center;"><em>Above are dummy URLS which MUST be replaced with actual working URLs</em></p>
+
+###### Verify Release Files
+```shell
+# if gpg --digest-algo SHA256 --verify /tmp/hashes.txt.sig >/dev/null 2>&1; then printf $'SHASUM file has a VALID signature!\n'; else printf $'SHASUMS failed signature check\n' && sleep 5 && exit 1; fi
+```
+
+###### Verify Hash, Unpack & Install Package
+```shell
+# if [[ $(cat /tmp/hashes.txt) =~ $(sha512sum /tmp/haveno*.zip | awk '{ print $1 }') ]] ; then printf $'SHA Hash IS valid!\n' && mkdir -p /usr/share/desktop-directories && cd /tmp && unzip /tmp/haveno*.zip && apt install -y /tmp/haveno*.deb; else printf $'WARNING: Bad Hash!\n' && exit; fi
+```
+
+###### Verify Jar
+```shell
+# if [[ $(cat /tmp/desktop*.SHA-256) =~ $(sha256sum /opt/haveno/lib/app/desktop*.jar | awk '{ print $1 }') ]] ; then printf $'SHA Hash IS valid!\n' && printf 'Happy trading!\n'; else printf $'WARNING: Bad Hash!\n' && exit; fi
+```
+
+#### *TemplateVM Building From Source via `git` Repository (Scripted)*
+##### In `dispXXXX` AppVM:
+```shell
+% bash haveno/scripts/install_qubes/scripts/1-TemplateVM/1.0-haveno-templatevm.sh "<JDK_PACKAGE_URL>" "<JDK_SHA_HASH>" "<SOURCE_URL>"
+```
+
+<p style="text-align: center;">Example:</p>
+
+```shell
+% bash haveno/scripts/install_qubes/scripts/1-TemplateVM/1.0-haveno-templatevm.sh "https://download.bell-sw.com/java/21.0.6+10/bellsoft-jdk21.0.6+10-linux-amd64.deb" "a5e3fd9f5323de5fc188180c91e0caa777863b5b" "https://github.com/haveno-dex/haveno"
+```
++ Upon Successful Compilation & Packaging, A `Filecopy` Confirmation Will Be Presented
+
++ Select "haveno-template" for "Target" of Pop-Up
+
++ Click OK
+
+##### In `haveno-template` TemplateVM:
+```shell
+% sudo apt install -y ./QubesIncoming/dispXXXX/haveno.deb
+```
+
+#### *NetVM (Scripted)*
+##### In `dispXXXX` AppVM:
+```shell
+$ qvm-copy haveno/scripts/install_qubes/scripts/2-NetVM/2.0-haveno-netvm.sh
+```
+
++ Select "sys-haveno" for "Target" Within Pop-Up
+
++ Click "OK" Button
+
+##### In `sys-haveno` NetVM:
+(Allow bootstrap process to complete)
+```shell
+% sudo zsh QubesIncoming/dispXXXX/2.0-haveno-netvm.sh
+```
+
+#### *NetVM (CLI)*
+##### In `sys-haveno` NetVM:
+###### Add `onion-grater` Profile
+```shell
+# onion-grater-add 40_haveno
+```
+
+###### Restart `onion-grater` Service
+```shell
+# systemctl restart onion-grater.service
+# poweroff
+```
+
+#### *AppVM (Scripted)*
+##### In `dispXXXX` AppVM:
+```shell
+$ qvm-copy haveno/scripts/install_qubes/scripts/3-AppVM/3.0-haveno-appvm.sh
+```
+
++ Select "haveno" for "Target" of Pop-Up
+
++ Click OK
+
+##### In `haveno` AppVM:
+```shell
+% sudo zsh QubesIncoming/dispXXXX/3.0-haveno-appvm.sh
+```
+
+#### *AppVM (CLI)*
+##### In `haveno` AppVM:
+###### Adjust `sdwdate` Configuration
+```shell
+# mkdir /usr/local/etc/sdwdate-gui.d
+# printf "gateway=sys-haveno\n" > /usr/local/etc/sdwdate-gui.d/50_user.conf
+# systemctl restart sdwdate
+```
+
+###### Prepare Firewall Settings via `/rw/config/rc.local`
+```shell
+# printf "\n# Prepare Local FW Settings\nmkdir -p /usr/local/etc/whonix_firewall.d\n" >> /rw/config/rc.local
+# printf "\n# Poke FW\nprintf \"EXTERNAL_OPEN_PORTS+=\\\\\" 9999 \\\\\"\\\n\" | tee /usr/local/etc/whonix_firewall.d/50_user.conf\n" >> /rw/config/rc.local
+# printf "\n# Restart FW\nwhonix_firewall\n\n" >> /rw/config/rc.local
+```
+
+###### View & Verify Change
+```shell
+# tail /rw/config/rc.local
+```
+
+<p style="text-align: center;"><b>Confirm output contains:</b></p>
+
+>		# Poke FW
+>		printf "EXTERNAL_OPEN_PORTS+=\" 9999 \"\n" | tee /usr/local/etc/whonix_firewall.d/50_user.conf
+>
+>		# Restart FW
+>		whonix_firewall
+
+###### Restart `whonix_firewall`
+```shell
+# whonix_firewall
+```
+
+###### Create `haveno-Haveno.desktop`
+```shell
+# mkdir -p /home/$(ls /home)/\.local/share/applications
+# sed 's|/opt/haveno/bin/Haveno|/opt/haveno/bin/Haveno --torControlPort=9051 --socks5ProxyXmrAddress=127.0.0.1:9050 --useTorForXmr=on|g' /opt/haveno/lib/haveno-Haveno.desktop > /home/$(ls /home)/.local/share/applications/haveno-Haveno.desktop
+# chown -R $(ls /home):$(ls /home) /home/$(ls /home)/.local/share/applications
+```
+
+###### View & Verify Change
+```shell
+# tail /home/$(ls /home)/.local/share/applications/haveno-Haveno.desktop
+```
+
+<p style="text-align: center;"><b>Confirm output contains:</b></p>
+
+>		[Desktop Entry]
+>		Name=Haveno
+>		Comment=Haveno
+>		Exec=/opt/haveno/bin/Haveno --torControlPort=9051 --socks5ProxyXmrAddress=127.0.0.1:9050 --useTorForXmr=on
+>		Icon=/opt/haveno/lib/Haveno.png
+>		Terminal=false
+>		Type=Application
+>		Categories=Network
+>		MimeType=
+
+###### Poweroff
+```shell
+# poweroff
+```
+
+### **Remove TemplateVM, NetVM & AppVM:**
+#### Scripted
+##### In `dom0`:
+```shell
+$ bash /tmp/haveno/0.3-dom0.sh
+```
+
+#### GUI
+##### Via `Qubes Manager`:
+
++ Highlight "haveno" (AppVM)
+
++ Click "Delete qube"
+
++ Enter "haveno"
+
++ Click "OK" Button
+
++ Highlight "haveno-template" (TemplateVM)
+
++ Click "Delete qube"
+
++ Enter "haveno-template"
+
++ Click "OK" Button
+
++ Highlight "sys-haveno" (NetVM)
+
++ Click "Delete qube"
+
++ Enter "sys-haveno"
+
++ Click "OK" Button
+
+#### CLI
+##### In `dom0`:
+```shell
+$ qvm-shutdown --force --quiet haveno haveno-template sys-haveno && qvm-remove --force --quiet haveno haveno-template sys-haveno
+```
diff --git a/scripts/install_whonix_qubes/README.md b/scripts/install_whonix_qubes/README.md
new file mode 100644
index 0000000000..5bfda7419e
--- /dev/null
+++ b/scripts/install_whonix_qubes/README.md
@@ -0,0 +1,75 @@
+# Install Haveno on Qubes/Whonix
+
+
+After you already have [`Qubes`](https://www.qubes-os.org/downloads) or [`Whonix`](https://www.whonix.org/wiki/Download) installed:
+
+1. Download [scripts](https://github.com/haveno-dex/haveno/tree/master/install_whonix_qubes/scripts/install_whonix_qubes/scripts).
+2. Move script(s) to their respective destination (`0.*-dom0.sh` -> `dom0`, `1.0-haveno-templatevm.sh` -> `haveno-template`, etc.).
+3. Consecutively execute the following commands in their respective destinations.
+
+---
+
+## **Create VMs**
+[`Qubes`](https://www.qubes-os.org/downloads)
+### **In `dom0`:**
+
+```shell
+$ bash 0.0-dom0.sh && bash 0.1-dom0.sh && bash 0.2-dom0.sh
+```
+
+[`Whonix`](https://www.whonix.org/wiki/Download) On Anything Other Than [`Qubes`](https://www.qubes-os.org/downloads)
+
+- Clone `Whonix Workstation` To VM Named `haveno-template`
+- Clone `Whonix Gateway` To VM Named `sys-haveno`
+- Create New Linked VM Clone Based On `haveno-template` Named `haveno`
+
+
+## **Build TemplateVM**
+### *Via Binary Archive*
+#### **In `haveno-template` `TemplateVM`:**
+
+```shell
+% sudo bash QubesIncoming/dispXXXX/1.0-haveno-templatevm.sh "<PACKAGE_ARCHIVE_URL>" "<PACKAGE_PGP_FINGERPRINT>"
+```
+
+<p style="text-align: center;">Example:</p>
+
+```shell
+% sudo bash 1.0-haveno-templatevm.sh "https://github.com/havenoexample/haveno-example/releases/download/v1.0.18/haveno-linux-deb.zip" "ABAF11C65A2970B130ABE3C479BE3E4300411886"
+```
+
+### *Via Source*
+#### **In `dispXXXX` `AppVM`:**
+```shell
+% bash 1.0-haveno-templatevm.sh "<JDK_PACKAGE_URL>" "<JDK_SHA_HASH>" "<SOURCE_URL>"
+```
+
+<p style="text-align: center;">Example:</p>
+
+```shell
+% bash 1.0-haveno-templatevm.sh "https://download.bell-sw.com/java/21.0.6+10/bellsoft-jdk21.0.6+10-linux-amd64.deb" "a5e3fd9f5323de5fc188180c91e0caa777863b5b" "https://github.com/haveno-dex/haveno"
+```
+
+#### **In `haveno-template` `TemplateVM`:**
+
+```shell
+% sudo apt install -y haveno.deb
+```
+
+## **Build NetVM**
+### **In `sys-haveno` `NetVM`:**
+
+```shell
+% sudo zsh 3.0-haveno-appvm.sh
+```
+
+## **Build AppVM**
+### **In `haveno` `AppVM`:**
+
+```shell
+% sudo zsh 3.0-haveno-appvm.sh
+```
+
+---
+
+Complete Documentation Can Be Found [Here](https://github.com/haveno-dex/haveno/blob/master/install_whonix_qubes/scripts/install_whonix_qubes/INSTALL.md).
diff --git a/scripts/install_whonix_qubes/scripts/0-dom0/0.0-dom0.sh b/scripts/install_whonix_qubes/scripts/0-dom0/0.0-dom0.sh
new file mode 100644
index 0000000000..5618cf1e12
--- /dev/null
+++ b/scripts/install_whonix_qubes/scripts/0-dom0/0.0-dom0.sh
@@ -0,0 +1,6 @@
+#!/bin/bash
+## ./haveno-on-qubes/scripts/0.0-dom0.sh
+
+## Create Haveno TemplateVM:
+qvm-clone whonix-workstation-17 haveno-template
+
diff --git a/scripts/install_whonix_qubes/scripts/0-dom0/0.1-dom0.sh b/scripts/install_whonix_qubes/scripts/0-dom0/0.1-dom0.sh
new file mode 100644
index 0000000000..befa8b6702
--- /dev/null
+++ b/scripts/install_whonix_qubes/scripts/0-dom0/0.1-dom0.sh
@@ -0,0 +1,6 @@
+#!/bin/bash
+## ./haveno-on-qubes/scripts/0.1-dom0.sh
+
+## Create Haveno NetVM:
+qvm-create --template whonix-gateway-17 --class AppVM --label=orange --property memory=512 --property maxmem=512 --property netvm=sys-firewall sys-haveno && qvm-prefs --set sys-haveno provides_network True
+
diff --git a/scripts/install_whonix_qubes/scripts/0-dom0/0.2-dom0.sh b/scripts/install_whonix_qubes/scripts/0-dom0/0.2-dom0.sh
new file mode 100644
index 0000000000..6f52637632
--- /dev/null
+++ b/scripts/install_whonix_qubes/scripts/0-dom0/0.2-dom0.sh
@@ -0,0 +1,7 @@
+#!/bin/bash
+## ./haveno-on-qubes/scripts/0.2-dom0.sh
+
+## Create Haveno AppVM:
+qvm-create --template haveno-template --class AppVM --label=orange --property memory=2048 --property maxmem=4096 --property netvm=sys-haveno haveno
+printf 'haveno-Haveno.desktop' | qvm-appmenus --set-whitelist - haveno
+
diff --git a/scripts/install_whonix_qubes/scripts/0-dom0/0.3-dom0.sh b/scripts/install_whonix_qubes/scripts/0-dom0/0.3-dom0.sh
new file mode 100644
index 0000000000..4bdae35533
--- /dev/null
+++ b/scripts/install_whonix_qubes/scripts/0-dom0/0.3-dom0.sh
@@ -0,0 +1,6 @@
+#!/bin/bash
+## ./haveno-on-qubes/scripts/0.3-dom0.sh
+
+## Remove Haveno GuestVMs
+qvm-shutdown --force --quiet haveno haveno-template sys-haveno && qvm-remove --force --quiet haveno haveno-template sys-haveno
+
diff --git a/scripts/install_whonix_qubes/scripts/1-TemplateVM/1.0-haveno-templatevm.sh b/scripts/install_whonix_qubes/scripts/1-TemplateVM/1.0-haveno-templatevm.sh
new file mode 100644
index 0000000000..f1ab43ae1b
--- /dev/null
+++ b/scripts/install_whonix_qubes/scripts/1-TemplateVM/1.0-haveno-templatevm.sh
@@ -0,0 +1,185 @@
+#!/bin/bash
+## ./haveno-on-qubes/scripts/1.1-haveno-templatevm_maker.sh
+
+
+function remote {
+	if [[ -z $PRECOMPILED_URL || -z $FINGERPRINT ]]; then
+	    printf "\nNo arguments provided!\n\nThis script requires two arguments to be provided:\nBinary URL & PGP Fingerprint\n\nPlease review documentation and try again.\n\nExiting now ...\n"
+	    exit 1
+	fi
+	## Update & Upgrade
+	apt update && apt upgrade -y
+
+
+	## Install wget
+	apt install -y wget
+
+
+	## Function to print messages in blue:
+	echo_blue() {
+	  echo -e "\033[1;34m$1\033[0m"
+	}
+
+
+	# Function to print error messages in red:
+	echo_red() {
+	  echo -e "\033[0;31m$1\033[0m"
+	}
+
+
+	## Sweep for old release files
+	rm *.asc desktop-*-SNAPSHOT-all.jar.SHA-256 haveno*
+
+
+	## Define URL & PGP Fingerprint etc. vars:
+	user_url=$PRECOMPILED_URL
+	base_url=$(printf ${user_url} | awk -F'/' -v OFS='/' '{$NF=""}1')
+	expected_fingerprint=$FINGERPRINT
+	binary_filename=$(awk -F'/' '{ print $NF }' <<< "$user_url")
+	package_filename="haveno.deb"
+	signature_filename="${binary_filename}.sig"
+	key_filename="$(printf "$expected_fingerprint" | tr -d ' ' | sed -E 's/.*(................)/\1/' )".asc
+	wget_flags="--tries=10 --timeout=10 --waitretry=5 --retry-connrefused --show-progress"
+
+
+	## Debug:
+	printf "\nUser URL=$user_url\n"
+	printf "\nBase URL=$base_url\n"
+	printf "\nFingerprint=$expected_fingerprint\n"
+	printf "\nBinary Name=$binary_filename\n"
+	printf "\nPackage Name=$package_filename\n"
+	printf "\nSig Filename=$signature_filename\n"
+	printf "\nKey Filename=$key_filename\n"
+
+
+	## Configure for tinyproxy:
+	export https_proxy=http://127.0.0.1:8082
+
+
+	## Download Haveno binary:
+	echo_blue "Downloading Haveno from URL provided ..."
+	wget "${wget_flags}" -cq "${user_url}" || { echo_red "Failed to download Haveno binary."; exit 1; }
+
+
+	## Download Haveno signature file:
+	echo_blue "Downloading Haveno signature ..."
+	wget "${wget_flags}" -cq "${base_url}""${signature_filename}" || { echo_red "Failed to download Haveno signature."; exit 1; }
+
+
+	## Download the GPG key:
+	echo_blue "Downloading signing GPG key ..."
+	wget "${wget_flags}" -cqO "${key_filename}" "https://keyserver.ubuntu.com/pks/lookup?op=get&search=0x$(echo "$expected_fingerprint" | tr -d ' ')" || { echo_red "Failed to download GPG key."; exit 1; }
+
+
+	## Import the GPG key:
+	echo_blue "Importing the GPG key ..."
+	gpg --import "${key_filename}" || { echo_red "Failed to import GPG key."; exit 1; }
+
+
+	## Extract imported fingerprints:
+	imported_fingerprints=$(gpg --with-colons --fingerprint | grep -A 1 'pub' | grep 'fpr' | cut -d: -f10 | tr -d '\n')
+
+
+	## Remove spaces from the expected fingerprint for comparison:
+	formatted_expected_fingerprint=$(echo "${expected_fingerprint}" | tr -d ' ')
+
+
+	## Check if the expected fingerprint is in the list of imported fingerprints:
+	if [[ ! "${imported_fingerprints}" =~ "${formatted_expected_fingerprint}" ]]; then
+	  echo_red "The imported GPG key fingerprint does not match the expected fingerprint."
+	  exit 1
+	fi
+
+
+	## Verify the downloaded binary with the signature:
+	echo_blue "Verifying the signature of the downloaded file ..."
+	if gpg --digest-algo SHA256 --verify "${signature_filename}" >/dev/null 2>&1; then
+	    7z x "${binary_filename}" && mv haveno*.deb "${package_filename}";
+	    else echo_red "Verification failed!" && sleep 5
+	    exit 1;
+	fi
+
+
+	echo_blue "Haveno binaries have been successfully verified."
+
+
+	# Install Haveno:
+	echo_blue "Installing Haveno ..."
+	apt install -y ./"${package_filename}" || { echo_red "Failed to install Haveno."; exit 1; }
+
+	## Finalize
+	echo_blue "Haveno TemplateVM installation and configuration complete."
+	echo_blue "\nHappy Trading\!\n"
+	printf "%s \n" "Press [ENTER] to complete ..."
+	read ans
+	#exit
+	poweroff
+}
+
+
+function build {
+	if [[ -z $JAVA_URL || -z $JAVA_SHA1 || -z $SOURCE_URL ]]; then
+	    printf "\nNo arguments provided!\n\nThis script requires three argument to be provided:\n\nURL for Java 21 JDK Debian Package\n\nSHA1 Hash for Java 21 JDK Debian Package\n\nURL for Remote Git Source Repository\n\nPlease review documentation and try again.\n\nExiting now ...\n"
+	    exit 1
+	fi
+	# Dependancies
+	sudo apt install -y make git expect fakeroot binutils
+
+	# Java
+	curl -fsSLo jdk21.deb ${JAVA_URL}
+	if [[ $(shasum ./jdk21.deb | awk '{ print $1 }') == ${JAVA_SHA1} ]] ; then printf $'SHA Hash IS valid!\n'; else printf $'WARNING: Bad Hash!\n' && exit; fi
+	sudo apt install -y ./jdk21.deb
+
+	# Build
+	git clone --depth=1 $SOURCE_URL
+	GIT_DIR=$(awk -F'/' '{ print $NF }' <<< "$SOURCE_URL")
+	cd ${GIT_DIR}
+	git checkout master
+	sed -i 's|XMR_STAGENET|XMR_MAINNET|g' desktop/package/package.gradle
+	./gradlew clean build --refresh-keys --refresh-dependencies
+
+	# Package
+	# Expect
+	cat <<DONE >> /tmp/haveno_package_deb.exp
+set send_slow {1 .1}
+proc send {ignore arg} {
+	sleep 1.1
+	exp_send -s -- \$arg
+}
+set timeout -1
+spawn ./gradlew packageInstallers --console=plain
+match_max 100000
+expect -exact ""
+send -- "y\r"
+expect -exact ""
+send -- "y\r"
+expect -exact ""
+send -- "y\r"
+expect -exact "app-image"
+send -- \x03
+expect eof
+DONE
+
+	# Package
+	expect -f /tmp/haveno_package_deb.exp && find ./ -name '*.deb' -exec qvm-copy {} \;
+	printf "\nHappy Trading!\n"
+
+}
+
+if ! [[ $# -eq 2 || $# -eq 3 ]] ; then
+	printf "\nFor this script to function, user supplied arguments are required.\n\n"
+	printf "\nPlease review documentation and try again.\n\n"
+fi
+
+if [[ $# -eq 2 ]] ; then
+    PRECOMPILED_URL=$1
+    FINGERPRINT=$2
+    remote
+fi
+
+if [[ $# -eq 3 ]] ; then
+    JAVA_URL=$1
+    JAVA_SHA1=$2
+    SOURCE_URL=$3
+    build
+fi
diff --git a/scripts/install_whonix_qubes/scripts/2-NetVM/2.0-haveno-netvm.sh b/scripts/install_whonix_qubes/scripts/2-NetVM/2.0-haveno-netvm.sh
new file mode 100644
index 0000000000..d29e61dcf5
--- /dev/null
+++ b/scripts/install_whonix_qubes/scripts/2-NetVM/2.0-haveno-netvm.sh
@@ -0,0 +1,30 @@
+#!/bin/zsh
+## ./haveno-on-qubes/scripts/2.0-haveno-netvm_taker.sh
+
+## Function to print messages in blue:
+echo_blue() {
+  echo -e "\033[1;34m$1\033[0m"
+}
+
+
+# Function to print error messages in red:
+echo_red() {
+  echo -e "\033[0;31m$1\033[0m"
+}
+
+
+## onion-grater
+# Add onion-grater Profile
+echo_blue "\nAdding onion-grater Profile ..."
+onion-grater-add 40_haveno
+
+
+# Restart onion-grater
+echo_blue "\nRestarting onion-grater Service ..."
+systemctl restart onion-grater.service
+echo_blue "Haveno NetVM configuration complete."
+printf "%s \n" "Press [ENTER] to complete ..."
+read ans
+#exit
+poweroff
+
diff --git a/scripts/install_whonix_qubes/scripts/3-AppVM/3.0-haveno-appvm.sh b/scripts/install_whonix_qubes/scripts/3-AppVM/3.0-haveno-appvm.sh
new file mode 100644
index 0000000000..11582a8314
--- /dev/null
+++ b/scripts/install_whonix_qubes/scripts/3-AppVM/3.0-haveno-appvm.sh
@@ -0,0 +1,61 @@
+#!/bin/zsh
+## ./haveno-on-qubes/scripts/3.0-haveno-appvm_taker.sh 
+
+## Function to print messages in blue:
+echo_blue() {
+  echo -e "\033[1;34m$1\033[0m"
+}
+
+
+# Function to print error messages in red:
+echo_red() {
+  echo -e "\033[0;31m$1\033[0m"
+}
+
+
+## Adjust sdwdate Configuration
+mkdir -p /usr/local/etc/sdwdate-gui.d
+printf "gateway=sys-haveno\n" > /usr/local/etc/sdwdate-gui.d/50_user.conf
+systemctl restart sdwdate
+
+
+## Prepare Firewall Settings
+echo_blue "\nConfiguring FW ..."
+printf "\n# Prepare Local FW Settings\nmkdir -p /usr/local/etc/whonix_firewall.d\n" >> /rw/config/rc.local
+printf "\n# Poke FW\nprintf \"EXTERNAL_OPEN_PORTS+=\\\\\" 9999 \\\\\"\\\n\" | tee /usr/local/etc/whonix_firewall.d/50_user.conf\n" >> /rw/config/rc.local
+printf "\n# Restart FW\nwhonix_firewall\n\n" >> /rw/config/rc.local
+
+
+## View & Verify Change
+echo_blue "\nReview the following output and be certain in matches documentation!\n"
+tail /rw/config/rc.local
+printf "%s \n" "Press [ENTER] to continue ..."
+read ans
+:
+
+
+## Restart FW
+echo_blue "\nRestarting Whonix FW ..."
+whonix_firewall
+
+
+### Create Desktop Launcher:
+echo_blue "Creating desktop launcher ..."
+mkdir -p /home/$(ls /home)/\.local/share/applications
+sed 's|/opt/haveno/bin/Haveno|/opt/haveno/bin/Haveno --torControlPort=9051 --torControlUseSafeCookieAuth --torControlCookieFile=/var/run/tor/control.authcookie --socks5ProxyXmrAddress=127.0.0.1:9050 --useTorForXmr=on|g' /opt/haveno/lib/haveno-Haveno.desktop > /home/$(ls /home)/.local/share/applications/haveno-Haveno.desktop
+chown -R $(ls /home):$(ls /home) /home/$(ls /home)/.local/share/applications/haveno-Haveno.desktop
+
+
+## View & Verify Change
+echo_blue "\nReview the following output and be certain in matches documentation!\n"
+tail /home/$(ls /home)/.local/share/applications/haveno-Haveno.desktop
+printf "%s \n" "Press [ENTER] to continue ..."
+read ans
+:
+
+echo_blue "Haveno AppVM configuration complete."
+echo_blue "Refresh applications via Qubes Manager GUI now."
+printf "%s \n" "Press [ENTER] to complete ..."
+read ans
+#exit
+poweroff